#include <windows.h>

#ifndef NO_INCLUDE_WHARFDATA
#include "wharfdata.h"
#endif

struct Settings {
  char BitmapPath[512];
  char TimeDelay[10];
  char WallpaperListPath[512];
  int hours, minutes, seconds;
  BOOL Sequenced, ReplaceAtStartup;
  long totaltime;
};

struct WallpaperRecord {
  char *path;
  int tiled;
};

struct  WallpaperRecordList{
  struct WallpaperRecord *wpr;
  struct WallpaperRecordList *next, *prev;
};

// Wallpaper Record List stuff...
extern void WPRLMovetoHead(struct WallpaperRecordList **listptr);
extern void WPRLMovetoTail(struct WallpaperRecordList **listptr);
extern BOOL WPRLMovetoEntry(struct WallpaperRecordList **listptr, char *entry);
extern void WPRLMoveNext(struct WallpaperRecordList **listptr, int i);
extern struct WallpaperRecordList *WPRLAdd(struct WallpaperRecordList **listptr, struct WallpaperRecord *data);
extern struct WallpaperRecordList *WPRLFree(struct WallpaperRecordList **listptr);
extern struct WallpaperRecordList *WPRLRemoveAll(struct WallpaperRecordList **listptr);

// Wallpaper Functions
extern int UseSpecificWallpaper(struct WallpaperRecordList **listptr, char *bitmap);

// Dialog Procedures
extern BOOL CALLBACK WallpaperManagerDlgProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
extern int ShowWallpaperManager(BOOL mod);
extern void CloseAndDestroyManager();

// Variables needed elsewhere
extern HINSTANCE hInst;
extern struct WallpaperRecordList *wallpapers, *current;
extern struct Settings settings;

#ifndef NO_INCLUDE_WHARFDATA
__declspec( dllexport ) int initModule(HWND parent, HINSTANCE dll, wharfDataType* wd);
__declspec( dllexport ) int quitModule(HINSTANCE dll);
#endif