#ifndef __SHELLEXT_H_
#define __SHELLEXT_H_

#include "resource.h"       // main symbols
#include "IContextMenuImpl.h"          // IContextMenu
#include "IShellExtInitImpl.h"         // IShellExtInit
#include <comdef.h>                    // Interface IDs

class ATL_NO_VTABLE CLSWallpaperExt :
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<CLSWallpaperExt, &CLSID_LSWallpaperExt>,
  public IShellExtInitImpl,
  public IContextMenuImpl
{
public:
  CLSWallpaperExt() :
    m_cFiles(0),
    m_bExtended(false)
  {
    // Create LSWallpaper Menu
    char buf[100];

    lswpMenu = ::CreatePopupMenu();

    strcpy(buf, "&Add Wallpaper(s)...");
    ::AppendMenu(lswpMenu, MF_STRING, IDM_ADDWALLPAPERS, buf);

    strcpy(buf, "&Manage Wallpapers...");
    ::AppendMenu(lswpMenu, MF_STRING, IDM_MANAGEWALLPAPERS, buf);
  }

  STDMETHOD(GetCommandString)(UINT, UINT, UINT*, LPSTR, UINT);
  STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO);
  STDMETHOD(QueryContextMenu)(HMENU, UINT, UINT, UINT, UINT);

  STDMETHOD(Initialize)(LPCITEMIDLIST, LPDATAOBJECT, HKEY);

DECLARE_REGISTRY_RESOURCEID(IDR_LSWALLPAPEREXT)
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CLSWallpaperExt)
  COM_INTERFACE_ENTRY(IShellExtInit)
  COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()

private:
  int m_cFiles;
  bool m_bExtended;
  vector<string> m_lstFiles;
  HMENU lswpMenu;
};

#endif